/* test.cdl import_C this header. */

#include <stdio.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>

#ifdef TECS

/* For the TECS generator 'tecsgen' */

/*
 * Tell to TECS generator that FILEptr is just an address.
 * There are two mean to do this.
 *  1) MrubyBridgePlugin doesn't handle pointer type as a return value.
 *     intptr_t can be accepted as an integer value.
 *  2) MrubyBridgePlugin handles FILE structure as call-by-value.
 *     It tries to create TECS::struct_iobuf (this name depends on the implementation) to handle FILE structure.
 *     This fails because it has pointers which cannot be handled by the plugin.
 */
typedef intptr_t FILEptr;
// typedef long     size_t;

#else

/* For the C-compiler */

typedef FILE *FILEptr;

/*
 * fnctl.h & stdio.h have to be import_C_ed at a time.
 * import_C accepts only typedef (not #define).
 * This means that guard code to avoid duplicate inclusion doesn't work.
 * (This reason is week because TECS generator does not read these headers actually)
 */

#endif

