# Execution:
#   % ./test.exe test.rb
#
# 1), 2) these cases read files using both Low-level & High-level File I/O.
# 3) write characters (code 0x20..0x3f) to test.txt.
#

#== UInt8Pointer  CharPointer ؤѴ
#
#u8p::           TECS::UInt8Pointer
#len:: Integer : u8p ͭĹ
#
# ϡString إԡäΤ
# String#[nth] Ԥư򤷤ƤʤInteger#chr ʤΤǡѤ
#
def uint8Pointer_to_string( u8p, len )
  len2 = u8p.length
  if len2 < len then
    len = len2
  end
  cp = TECS::CharPointer.new( len + 1 )

  i = 0
  while( i < len )
    cp[i] = u8p[i]
    i+=1
  end
  cp[i] = 0

  return cp.to_s
end


print "[create object]\n"
file_name = "test.rb"
object = TECS::TsLowFile.new( 'CsLowFile' )
name = TECS::CharPointer.new( file_name.length + 1 )
name.from_s "test.rb"

print "[open file] " + name.to_s + "\n"
fd = object.open(name, 0, 0)
print " fd=#{fd}\n"
if fd < 0 then
  print "error fail to open faile #{name}\n"
  exit 1
end

buf = TECS::UInt8Pointer.new( 256 )
len = object.read(fd, buf, 256)
print "  read length=#{len}\n"
print( uint8Pointer_to_string( buf, len ) )

print "[close file] " + name.to_s + "\n"
err = object.close(fd)

print "\n\n2) ==== File ====\n"
object = TECS::TsFile.new( 'CsFile' )
name = TECS::CharPointer.new( 64 )
name.from_s "test.cdl"
mode = TECS::CharPointer.new( 4 )
mode.from_s "r"

print "[fopen] #{name} #{mode}\n"
fp = object.fopen(name, mode)
if fp == 0 then
  print "error fail to open file '#{name}'\n"
  exit 1
end

print "[fread] #{name}\n"
buf = TECS::UInt8Pointer.new( 256 )
len = object.fread(buf,1,256,fp)

print "[len] #{len}\n"
print( uint8Pointer_to_string( buf, len ) )

print "[fclose] #{name}\n"
object.fclose(fp)

print "\n\n3) ==== File (write) ====\n"
# object, name, mode, buf Ϻ

name.from_s "test.txt"
mode.from_s "w"

print "[fopen] #{name} #{mode}\n"
fp = object.fopen(name, mode)
if fp == 0 then
  print "error fail to open file '#{name}'\n"
  exit 1
end

len = 32
i = 0
while i < len
  buf[i] = 32 + i
  i += 1
end

print "[fwrite] #{name}\n"
len = object.fwrite(buf,1,len,fp)

print "[fclose] #{name}\n"
object.fclose(fp)
