# -*- coding: euc-jp -*-
#
#  TECS Generator
#      Generator for TOPPERS Embedded Component System
#  
#   Copyright (C) 2008-2013 by TOPPERS Project
#--
#   嵭Ԥϡʲ(1)(4)ξ˸¤ꡤܥեȥ
#   ܥեȥѤΤޤࡥʲƱˤѡʣ
#   ѡۡʰʲѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
#   (1) ܥեȥ򥽡ɤηѤˤϡ嵭
#       ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
#       ˴ޤޤƤ뤳ȡ
#   (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
#       ѤǤǺۤˤϡۤȼɥȡ
#       ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
#       ̵ݾڵǺܤ뤳ȡ
#   (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
#       ѤǤʤǺۤˤϡΤ줫ξ
#       ȡ
#     (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
#         ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
#     (b) ۤη֤̤ˡˤäơTOPPERSץȤ
#         𤹤뤳ȡ
#   (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
#       ⡤嵭ԤTOPPERSץȤդ뤳ȡ
#       ޤܥեȥΥ桼ޤϥɥ桼Τʤ
#       ͳ˴Ťᤫ⡤嵭ԤTOPPERSץȤ
#       դ뤳ȡ
#  
#   ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
#   TOPPERSץȤϡܥեȥ˴ؤơλŪ
#   ФŬޤơʤݾڤԤʤޤܥեȥ
#   ѤˤľŪޤϴŪʤ»˴ؤƤ⡤
#   Ǥʤ
#  
#   $Id: tecsgen.rb 1943 2013-04-30 01:37:51Z okuma-top $
#++


module TECSGEN

  #=== import ѥ (-I) ɲ
  # ϿѤߤǤСɲäʤ
  def self.add_import_path path
    if $import_path.index( path ) == nil then
      dbgPrint "add_import_path: '#{path}'\n"
      $import_path << path
    end
  end

  #=== EXEB ǤΥѥĴ
  # Ķѿ TECSPATH  cygwin ȡexerb ǤǤϰʤ
  # $import_path  $TECSPATH Ĵ
  def self.adjust_exerb_path
    if $IN_EXERB then
      new_tecspath = cygpath( $tecspath, $tecspath )
      pattern = /\A#{$tecspath}/
      paths = []
      $import_path.each{ |path|
        # cygpath  '..' 󤷤ƤޤΤǡnew_tecspath ִ
        # paths << cygpath( path, path )
        paths << path.sub( pattern, new_tecspath )
      }
      $import_path = paths
      $tecspath = new_tecspath
    else
      return
    end
  end

  #=== $(TECSPATH) ؤִ
  #path::String   : ENV[ 'TECSPATH' ] ˰פʬС "$(TECSPATH)" ִ
  #b_global::Bool : true ʤ gsub ִfalse ʤ sub ִ
  def self.subst_tecspath( path, b_global = false )
    tp = $tecspath.dup
    tp.gsub!( /\\/, "\\\\\\\\" )
    pattern = /#{tp}/
      substr = "$(TECSPATH)"
    if b_global then
      str =  path.gsub( pattern, substr )
    else
      str = path.sub( pattern, substr )
    end
    dbgPrint "subst_tecspath #{path}, #{str}\n"
    return str
  end

  #=== path Хѥ?
  #path:: String   :
  # '/' ޤ '$' ǻϤޤ硢ХѥȽꤹ
  def self.is_absolute_path?( path )
    pa = path[0..0]; pa2 = path[0..1]
    if pa == '/' || pa == '$' || pa2 =~ /[A-Za-z]:/ then
      res = true
    else
      res = false
    end
    dbgPrint "is_absolute( #{path} ) = #{res}  #{path[0]}\n"
    return res
  end

  ###
  #== Makefile.templ νƤɲáѹ뤿
  module Makefile
    @@objs = []
    @@vars = { }
    @@var_comments = { }
    @@ldflags = []
    @@search_path = []
    @@pre_tecsgen_target = []
    @@post_tecsgen_target = []

    #=== OTHER_OBJS ɲä
    def self.add_obj obj
      @@objs << obj
    end
    #=== ɲäѿ
    def self.add_var( var, val, comment = nil )
      if @@vars[ var.to_sym ] then
        @@vars[ var.to_sym ] << val
        @@var_comments[ var.to_sym ] << comment
      else
        @@vars[ var.to_sym ] = [ val ]
        @@var_comments[ var.to_sym ] = [ comment]
      end
    end
    #=== LDFLAGS ɲä
    def self.add_ldflag ldflag
      @@ldflags << ldflag
    end
    #=== ѥɲä
    # CFLAGS, vpath ɲä
    def self.add_search_path path
      @@search_path << path
    end
    #=== PRE_TECSGEN_TARGET ɲä
    # PRE_TECSGEN_TARGET  target ɲä
    def self.add_pre_tecsgen_target target
      @@pre_tecsgen_target << pre_tecsgen_target
    end
    #=== POST_TECSGEN_TARGET ɲä
    # POST_TECSGEN_TARGET  target ɲä
    def self.add_pre_tecsgen_target target
      @@post_tecsgen_target << pre_tecsgen_target
    end

    def self.get_objs  # Array ֤
      return @@objs.uniq
    end
    def self.get_vars  # Hash ֤
      return @@vars
    end
    def self.get_var_comments  # Hash ֤
      return @@var_comments
    end
    def self.get_ldflags  # Array ֤
      return @@ldflags.uniq
    end
    def self.get_search_path  # Array ֤
      return @@search_path.uniq
    end
    def self.get_pre_tecsgen_target  # Array ֤
      return @@pre_tecsgen_target.uniq
    end
    def self.get_post_tecsgen_target  # Array ֤
      return @@post_tecsgen_target.uniq
    end
  end
end
