# -*- coding: euc-jp -*-
#
#  TECS Generator
#      Generator for TOPPERS Embedded Component System
#  
#   Copyright (C) 2008-2013 by TOPPERS Project
#--
#   嵭Ԥϡʲ(1)(4)ξ˸¤ꡤܥեȥ
#   ܥեȥѤΤޤࡥʲƱˤѡʣ
#   ѡۡʰʲѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
#   (1) ܥեȥ򥽡ɤηѤˤϡ嵭
#       ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
#       ˴ޤޤƤ뤳ȡ
#   (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
#       ѤǤǺۤˤϡۤȼɥȡ
#       ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
#       ̵ݾڵǺܤ뤳ȡ
#   (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
#       ѤǤʤǺۤˤϡΤ줫ξ
#       ȡ
#     (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
#         ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
#     (b) ۤη֤̤ˡˤäơTOPPERSץȤ
#         𤹤뤳ȡ
#   (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
#       ⡤嵭ԤTOPPERSץȤդ뤳ȡ
#       ޤܥեȥΥ桼ޤϥɥ桼Τʤ
#       ͳ˴Ťᤫ⡤嵭ԤTOPPERSץȤ
#       դ뤳ȡ
#  
#   ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
#   TOPPERSץȤϡܥեȥ˴ؤơλŪ
#   ФŬޤơʤݾڤԤʤޤܥեȥ
#   ѤˤľŪޤϴŪʤ»˴ؤƤ⡤
#   Ǥʤ
#  
#   $Id: C2TECSBridgePlugin.rb 1951 2013-05-01 08:48:13Z okuma-top $
#++

#== C => TECS ƤӽФΥץ饰
class C2TECSBridgePlugin < SignaturePlugin
#@signature:: Signature   ץ饰оݤȤʤ륷˥
#@option:: String   '"', '"' ǰϤޤ줿ʸ

  @@signature_list = { }

  #signature::     Signature        ˥ʥ󥹥󥹡
  def initialize( signature, option )
    super

    @signature = signature
    @header_name = "#{$gen}/#{@signature.get_global_name}.h"
    @celltype_name = :"t#{@signature.get_global_name}"

    parse_plugin_arg
  end

  def gen_cdl_file file
    if @@signature_list[ @signature.get_global_name ] then
      @@signature_list[ @signature.get_global_name ] << self
      cdl_warning( "C2TW001 signature '$1' duplicate. ignored current one", @signature.get_namespace_path )
      return
    end

    @@signature_list[ @signature.get_global_name ] = [ self ]
    print_msg "  C2TECSBridgePlugin: [celltype] C2TECS::#{@celltype_name}. Create cell then join the call port 'cCall' to the target cell\n"
    file.print <<EOT
namespace nC2TECS{
  [singleton, active]    // this celltype is not active actually. 'active' is specified to prevent W1002.
  celltype #{@celltype_name} {
    call #{@signature.get_namespace_path} cCall;
  };
};
EOT
  end

  #=== Υɤ
  #ץ饰θΥɤ
  #file:: File: 
  def self.gen_post_code( file )
    # ʣΥץ饰 post_code ĤΥե˴ޤޤ뤿ᡢʲΤ褦ʸФĤ뤳
    # file.print "/* '#{self.class.name}' post code */\n"
  end

  #===  ؿ(C)
  #     ̾ǤСͥ졼ϼؿΥƥץ졼Ȥ
  #     ץ饰ξ硢ѹɬפΤʤ륿ץɤ
  #file::           FILE        ե
  #b_singleton::    bool        true if singleton
  #ct_name::        Symbol
  #global_ct_name:: string
  #sig_name::       string
  #ep_name::        string
  #func_name::      string
  #func_global_name:: string
  #func_type::      class derived from Type
  def gen_ep_func_body( file, b_singleton, ct_name, global_ct_name, sig_name, ep_name, func_name, func_global_name, func_type, params )

    # nothing to do

  end


  def gen_postamble( file, b_singleton, ct_name, global_name )

    file.print <<EOT
/*
 * This file was generated by C2TECSBridgePlugin and has prototype
 * decalarations of functions in signature '#{@signature.get_namespace_path}'
 */

EOT

    # generate C functions calling function of call port
    @signature.get_function_head_array.each { |func_head|
      func_name = func_head.get_name
      ret_type  = func_head.get_return_type
      params    = func_head.get_paramlist.get_items

      # p "celltype_name, sig_name, func_name, func_global_name"
      # p "#{ct_name}, #{sig_name}, #{func_name}, #{func_global_name}"

      # function header
      file.print( "#{ret_type.get_type_str}\n" )
      file.print( "#{func_name}(" )

      delim = ""
      params.each{ |param|
        file.printf( "#{delim} #{param.get_type.get_type_str} #{param.get_name}#{param.get_type.get_type_str_post}" )
        delim = ","
      }
      file.print( " )\n{\n" )

      # call function in call port
      if ! ret_type.is_void? then
        file.print( "  #{ret_type.get_type_str}  retval;\n" )
        file.print( "  retval = " )
      else
        file.print( "  " )
      end

      file.print( "cCall_#{func_name}(" )

      delim = ""
      params.each{ |param|
        file.printf( "#{delim} #{param.get_name}" )
        delim = ","
      }
      file.print( " );\n" )

      if ! ret_type.is_void? then
        file.print( "  return retval;\n" )
      end
      file.print( "}\n\n" )
    }

  end

end

