# -*- coding: euc-jp -*-
#
#  TECS Generator
#      Generator for TOPPERS Embedded Component System
#  
#   Copyright (C) 2008-2013 by TOPPERS Project
#--
#   嵭Ԥϡʲ(1)(4)ξ˸¤ꡤܥեȥ
#   ܥեȥѤΤޤࡥʲƱˤѡʣ
#   ѡۡʰʲѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
#   (1) ܥեȥ򥽡ɤηѤˤϡ嵭
#       ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
#       ˴ޤޤƤ뤳ȡ
#   (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
#       ѤǤǺۤˤϡۤȼɥȡ
#       ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
#       ̵ݾڵǺܤ뤳ȡ
#   (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
#       ѤǤʤǺۤˤϡΤ줫ξ
#       ȡ
#     (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
#         ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
#     (b) ۤη֤̤ˡˤäơTOPPERSץȤ
#         𤹤뤳ȡ
#   (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
#       ⡤嵭ԤTOPPERSץȤդ뤳ȡ
#       ޤܥեȥΥ桼ޤϥɥ桼Τʤ
#       ͳ˴Ťᤫ⡤嵭ԤTOPPERSץȤ
#       դ뤳ȡ
#  
#   ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
#   TOPPERSץȤϡܥեȥ˴ؤơλŪ
#   ФŬޤơʤݾڤԤʤޤܥեȥ
#   ѤˤľŪޤϴŪʤ»˴ؤƤ⡤
#   Ǥʤ
#  
#   $Id: TECS2CBridgePlugin.rb 1951 2013-05-01 08:48:13Z okuma-top $
#++

#== TECS => C ƤӽФץ饰
class TECS2CBridgePlugin < SignaturePlugin
#@signature:: Signature   ץ饰оݤȤʤ륷˥
#@option:: String   '"', '"' ǰϤޤ줿ʸ

  @@signature_list = { }

  #signature::     Signature        ˥ʥ󥹥󥹡
  def initialize( signature, option )
    super

    @signature = signature
    @header_name = "#{$gen}/#{@signature.get_global_name}.h"
    @celltype_name = :"t#{@signature.get_global_name}"

    parse_plugin_arg
  end

  def gen_cdl_file file
    if @@signature_list[ @signature.get_global_name ] then
      @@signature_list[ @signature.get_global_name ] << self
      cdl_warning( "T2CW001 signature '$1' duplicate. ignored current one", @signature.get_namespace_path )
      return
    end
    @@signature_list[ @signature.get_global_name ] = [ self ]

    print_msg "  TECS2CBridgePlugin: [celltype] TECS2C::#{@celltype_name}. Create cell then join to entry port 'eEntry' from the caller cell\n"
    file.print <<EOT
namespace nTECS2C{
  [singleton]
  celltype #{@celltype_name} {
    [inline]
    entry #{@signature.get_namespace_path} eEnt;
  };
};
EOT
  end

  #=== Υɤ
  #ץ饰θΥɤ
  #file:: File: 
  def self.gen_post_code( file )
    # ʣΥץ饰 post_code ĤΥե˴ޤޤ뤿ᡢʲΤ褦ʸФĤ뤳
    # file.print "/* '#{self.class.name}' post code */\n"
  end

  #===  ؿ(C)
  #     ̾ǤСͥ졼ϼؿΥƥץ졼Ȥ
  #     ץ饰ξ硢ѹɬפΤʤ륿ץɤ
  #file::           FILE        ե
  #b_singleton::    bool        true if singleton
  #ct_name::        Symbol
  #global_ct_name:: string
  #sig_name::       string
  #ep_name::        string
  #func_name::      string
  #func_global_name:: string
  #func_type::      class derived from Type
  def gen_ep_func_body( file, b_singleton, ct_name, global_ct_name, sig_name, ep_name, func_name, func_global_name, func_type, params )

    ret_type = func_type.get_type
    b_ret_void = ret_type.is_void?

    if ! b_ret_void then
      file.print( "  #{ret_type.get_type_str}  retval;\n" )
    end

    if ! b_singleton then

      file.print <<EOT
  #{ct_name}_CB    *p_cellcb;
  if( VALID_IDX( idx ) ){
    p_cellcb = #{global_ct_name}_GET_CELLCB(idx);
  }else{
     /* 顼ɤ򤳤˵ */
  }

EOT
    end

    # p "celltype_name, sig_name, func_name, func_global_name"
    # p "#{ct_name}, #{sig_name}, #{func_name}, #{func_global_name}"

    if ! b_ret_void then
      file.print( "  retval = " )
    else
      file.print( "  " )
    end

    file.print( "#{func_name}(" )

    delim = ""
    params.each{ |param|
      file.printf( "#{delim} #{param.get_name}" )
      delim = ","
    }

    file.print( " );\n" )

    if ! b_ret_void then
      file.print( "  return retval;\n" )
    end

  end


  def gen_postamble( file, b_singleton, ct_name, global_name )

    # generate header file here, NOT postamble
    file2 = CFile.open( @header_name, "w" )
    file2.print <<EOT
/*
 * This file was generated by TECS2CBridgePlugin and has prototype
 * decalarations of functions in signature '#{@signature.get_namespace_path}'
 */

#include "global_tecsgen.h"

EOT
    @signature.get_function_head_array.each { |f|
      decl = f.get_declarator
      func_type = decl.get_type
      params = func_type.get_paramlist.get_items
      func_name = decl.get_name

      ret_type = func_type.get_type

      # p "celltype_name, sig_name, func_name, func_global_name"
      # p "#{ct_name}, #{sig_name}, #{func_name}, #{func_global_name}"

      file2.print( "#{ret_type.get_type_str}  #{func_name}(" )

      delim = ""
      params.each{ |param|
        file2.printf( "#{delim} #{param.get_name}" )
        delim = ","
      }
      
      file2.print( " )#{ret_type.get_type_str_post};\n" )
    }

      file2.close
  end

end

